//"pitdata.sci","Dane deklaracji",12007,0,1.0.0,SYSTEM,12647
//"Deklaracje podatkowe",2400,14,16

// dispatch listy komunikatw
dispatch xInfo = xFactory.komunikaty
dispatch xMessage

string sInfoPola
int infoZalacznika

int sub AddInfoPole(string nrpola, int zalacznik)
	if sInfoPola != "" then sInfoPola = sInfoPola + ", "

	if zalacznik && infoZalacznika == 0 then
		sInfoPola = sInfoPola + ": "
		infoZalacznika = 1
	endif 
	
	sInfoPola = sInfoPola + nrpola
endsub

//#define ER_DEXML_WYMAGANE		-4743
int sub CzyWypelnionePitPola()
	if sInfoPola == "" then 
		CzyWypelnionePitPola = 1
	else
		xMessage = xInfo.AddNew()
		xMessage.id = 4743
		xMessage.tresc = sInfoPola
		xMessage.status = 1
		CzyWypelnionePitPola = 0
	endif
endsub

#define XTdePIT_28A     9011
#define XTdePIT_28B     9012
#define XTdePIT_B		9027

// dispatch deklaracji
Record DeklaracjaData
	dispatch xDeklaracja, xPola, xPitPole, xZalaczniki
	int iizalacznik

	int sub LoadData(long idde)
		xDeklaracja = xFactory.NewObject("BDeklaracjaPodatkowa")
		if xDeklaracja.Load(using "id_de=%d", idde) then message "Nie mona zaadowa obiektu deklaracji" : error""
		xZalaczniki = xDeklaracja.zalaczniki
		iizalacznik = 0
		xPola = xDeklaracja.pola
		xPola.sort = "+$+id_op"
	endsub

	int sub CzyZalacznik()
		long id_xt = xDeklaracja.id_xt
		if id_xt == XTdePIT_28A || id_xt == XTdePIT_28B || id_xt == XTdePIT_B then CzyZalacznik = 1
	endsub
	
	int sub IndexPola( string nrpola )
		int ii, iicount, iipole
		
		iipole = 0
		ii = 1
		iicount = xPola.Count()
		while ( ii <= iicount && iipole == 0 )
			if xPola.item(ii).numer == nrpola then iipole = ii
			ii += 1
		wend

		IndexPola = iipole
	endsub

	string sub PitPole( string nrpola, int typpola, int wymagane )
		int mask

		xPitPole = xPola.item( IndexPola(nrpola) )

		select case typpola
		case TYPPOLA_Tekst
			PitPole = xPitPole.tekst
		case TYPPOLA_Data
			PitPole = xPitPole.data
		case TYPPOLA_Wybor
			mask = xPitPole.wybor
			if (mask & 1) then PitPole = "1"
			if (mask & 2) then PitPole = "2"
			if (mask & 4) then PitPole = "3"
			if (mask & 8) then PitPole = "4"
		case TYPPOLA_Liczba
			if xPitPole.liczba != 0  || wymagane then PitPole = using "%d", xPitPole.liczba
		case TYPPOLA_Kwota
			if xPitPole.kwota != 0.0 || wymagane then PitPole = using "%.2f", Round(xPitPole.kwota, 2)
		case TYPPOLA_KwotaZaokr
			if xPitPole.kwota != 0.0 || wymagane then PitPole = using "%.0f", Round(xPitPole.kwota, 0)
		case else
			message "Nieznany typ pola" : error""
		endselect
		
		if PitPole == "" && wymagane then AddInfoPole(nrpola, CzyZalacznik())
	endsub
	
	string sub KodFormularza()
		KodFormularza = xDeklaracja.kod
	endsub
	
	long sub GetZalacznik()
		int iicount
		iicount = xZalaczniki.Count()
		if iicount > 0 then
			iizalacznik += 1
			if iizalacznik <= iicount then GetZalacznik = xZalaczniki.item(iizalacznik).id_de
		endif
	endsub
	
endrec

// deklaracja podstawowa
DeklaracjaData Deklaracja
Deklaracja.LoadData(idde)

// deklaracja moe mie zaczniki 
DeklaracjaData Zalacznik
long idZalacznik = 0

// public
string sub PitPole( string nrpola, int typpola, int wymagane )
	if idZalacznik != 0 then
		PitPole = Zalacznik.PitPole( nrpola, typpola, wymagane )
	else
		PitPole = Deklaracja.PitPole( nrpola, typpola, wymagane )
	endif
endsub

// public
string sub PitPoleNr( int nr, int typpola, int wymagane )
	string nrpola = using "%d", nr
	if idZalacznik != 0 then
		PitPoleNr = Zalacznik.PitPole( nrpola, typpola, wymagane )
	else
		PitPoleNr = Deklaracja.PitPole( nrpola, typpola, wymagane )
	endif
endsub

// public
string sub PitKodUrzedu( int nr )
	string nrpola = using "%d", nr
	PitKodUrzedu = PitPole("e-" + nrpola, TYPPOLA_Tekst, 1)
endsub

// public
string sub GetZalacznik()
	idZalacznik = Deklaracja.GetZalacznik()
	if idZalacznik != 0 then
		Zalacznik.LoadData(idZalacznik)
		GetZalacznik = Zalacznik.KodFormularza()
	endif
endsub

int sub CzyPuste( string nrpola, int typpola )
	if PitPole(nrpola, typpola, 0) == "" then CzyPuste = 1
endsub

int sub CzyZero( int nr )
	string nrpola = using "%d", nr
	CzyZero = CzyPuste(nrpola, TYPPOLA_Kwota)
endsub

// wartosci dla deklaracji VAT-UE
#define TYPzzVATUE	107
#define BAS_DE		49

Record VatUEData
	InfoVatUE dostawy(1)
	InfoVatUE nabycia(1)
	InfoVatUE uslugi(1)

	int sub LoadData(long idde)
		
		int count_dostawy, count_nabycia, count_uslugi
		int trojstronna
		string sNip

		int zz = Open KatalogGrupy()+"61ZZ.dat" For base "ZZ"
		BaseError( zz,4 )

		SetKey(zz,"cross1")
		SetKeySeg(zz,"typ",TYPzzVATUE)
		SetKeySeg(zz,"baza1",BAS_DE)
		SetKeySeg(zz,"id1",idde)
		int err=GetRec(zz,GE)

		count_dostawy = 0
		count_nabycia = 0
		count_uslugi  = 0
		while !err && GetField(zz,"typ") == TYPzzVATUE && GetField(zz,"baza1") == BAS_DE && GetField(zz,"id1") == idde
			if GetField(zz,"baza2") == 0 then //dostawa
				count_dostawy += 1
				if count_dostawy > 1 then grow dostawy,1
				sNip = GetField(zz,"kod2")
				dostawy(count_dostawy).sNIP  = Mid(sNip, 3, Len(sNip)-2) 
				dostawy(count_dostawy).sKraj = Mid(sNip, 1, 2)
				dostawy(count_dostawy).dKwota = Round(GetField(zz,"ilosc"), 0)
				dostawy(count_dostawy).sTT = "1"
				if GetField(zz,"long") then dostawy(count_dostawy).sTT = "2"
			endif
			if GetField(zz,"baza2") == 1 then //nabycie
				count_nabycia += 1
				if count_nabycia > 1 then grow nabycia,1
				sNip = GetField(zz,"kod2")
				nabycia(count_nabycia).sNIP  = Mid(sNip, 3, Len(sNip)-2)
				nabycia(count_nabycia).sKraj = Mid(sNip, 1, 2)
				nabycia(count_nabycia).dKwota = Round(GetField(zz,"ilosc"), 0)
				nabycia(count_nabycia).sTT = "1"
				if GetField(zz,"long") then nabycia(count_nabycia).sTT = "2"
			endif
			if GetField(zz,"baza2") == 2 then //usluga
				count_uslugi += 1
				if count_uslugi > 1 then grow uslugi,1
				sNip = GetField(zz,"kod2")
				uslugi(count_uslugi).sNIP  = Mid(sNip, 3, Len(sNip)-2)
				uslugi(count_uslugi).sKraj = Mid(sNip, 1, 2)
				uslugi(count_uslugi).dKwota = Round(GetField(zz,"ilosc"), 0)
			endif
			err = GetRec(zz,NX)
		wend

	endsub

	int sub GetIloscDostaw()
		int count_dostawy = size(dostawy)
		if count_dostawy == 1 && dostawy(1).sNIP == "" then count_dostawy = 0
		GetIloscDostaw = count_dostawy
	endsub

	int sub GetIloscNabyc()
		int count_nabycia = size(nabycia)
		if count_nabycia == 1 && nabycia(1).sNIP == "" then count_nabycia = 0
		GetIloscNabyc = count_nabycia
	endsub

	int sub GetIloscUslug()
		int count_uslugi = size(uslugi)
		if count_uslugi == 1 && uslugi(1).sNIP == "" then count_uslugi = 0
		GetIloscUslug = count_uslugi
	endsub

endrec

VatUEData VatUE
if Mid(Deklaracja.KodFormularza(),1,6) == "VAT-UE" then VatUE.LoadData(idde)

int sub GetIloscVatUE(int typue)
	if typue == TYPUE_WDT then GetIloscVatUE = VatUE.GetIloscDostaw()
	if typue == TYPUE_WNT then GetIloscVatUE = VatUE.GetIloscNabyc()
	if typue == TYPUE_WSU then GetIloscVatUE = VatUE.GetIloscUslug()
endsub

int sub GetInfoVatUE(int typue, int iivatue, InfoVatUE info)
	if typue == TYPUE_WDT then info = VatUE.dostawy(iivatue)
	if typue == TYPUE_WNT then info = VatUE.nabycia(iivatue)
	if typue == TYPUE_WSU then info = VatUE.uslugi(iivatue)
endsub


